Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mortbay.servlet
Class UserAgentFilter

    java.lang.Object
      org.mortbay.servlet.UserAgentFilter

All Implemented Interfaces:
  Filter

Direct Known Subclasses:
  GzipFilter

    public class UserAgentFilter

extends Object
implements Filter

User Agent Filter.

This filter allows efficient matching of user agent strings for downstream or extended filters to use for browser specific logic.

The filter is configured with the following init parameters:

attribute
  If set, then the request attribute of this name is set with the matched user agent string
cacheSize
  The size of the user-agent cache, used to avoid reparsing of user agent strings. The entire cache is flushed when this size is reached
userAgent
  A regex `Pattern` to extract the essential elements of the user agent. The concatenation of matched pattern groups is used as the user agent name

An example value for pattern is `(?:Mozilla[^\(]*\(compatible;\s*+([^;]*);.*)|(?:.*?([^\s]+/[^\s]+).*)`. These two pattern match the common compatibility user-agent strings and extract the real user agent, failing that, the first element of the agent string is returned.

Author:
  gregw

Constructor Summary
`UserAgentFilter()`

Method Summary
`void` | `destroy()` Called by the web container to indicate to a filter that it is being taken out of service.
`void` | `doFilter(ServletRequest request, ServletResponse response, FilterChain chain)` The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain.
`String` | `getUserAgent(ServletRequest request)`
`String` | `getUserAgent(String ua)` Get UserAgent.
`void` | `init(FilterConfig filterConfig)` Called by the web container to indicate to a filter that it is being placed into service.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UserAgentFilter

    public UserAgentFilter()

Method Detail

### destroy

    public void destroy()

  Description copied from interface: `Filter`
  Called by the web container to indicate to a filter that it is being taken out of service. This method is only called once all threads within the filter's doFilter method have exited or after a timeout period has passed. After the web container calls this method, it will not call the doFilter method again on this instance of the filter.
  This method gives the filter an opportunity to clean up any resources that are being held (for example, memory, file handles, threads) and make sure that any persistent state is synchronized with the filter's current state in memory.

  Specified by:
    `destroy` in interface `Filter`

### doFilter

    public void doFilter(ServletRequest request,
                         ServletResponse response,
                         FilterChain chain)
                  throws IOException,
                         ServletException

  Description copied from interface: `Filter`
  The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain. The FilterChain passed in to this method allows the Filter to pass on the request and response to the next entity in the chain.

  A typical implementation of this method would follow the following pattern:-
  1. Examine the request
  2. Optionally wrap the request object with a custom implementation to filter content or headers for input filtering
  3. Optionally wrap the response object with a custom implementation to filter content or headers for output filtering
  4. a) Either invoke the next entity in the chain using the FilterChain object (`chain.doFilter()`),
  4. b) or not pass on the request/response pair to the next entity in the filter chain to block the request processing
  5. Directly set headers on the response after invocation of the next entity in the filter chain.

  Specified by:
    `doFilter` in interface `Filter`
  Throws:
    `IOException`
    `ServletException`

### init

    public void init(FilterConfig filterConfig)
              throws ServletException

  Description copied from interface: `Filter`
  Called by the web container to indicate to a filter that it is being placed into service. The servlet container calls the init method exactly once after instantiating the filter. The init method must complete successfully before the filter is asked to do any filtering work.
  The web container cannot place the filter into service if the init method either
  1.Throws a ServletException
  2.Does not return within a time period defined by the web container

  Specified by:
    `init` in interface `Filter`
  Throws:
    `ServletException`

### getUserAgent

    public String getUserAgent(ServletRequest request)

### getUserAgent

    public String getUserAgent(String ua)

  Get UserAgent. The configured agent patterns are used to match against the passed user agent string. If any patterns match, the concatenation of pattern groups is returned as the user agent string. Match results are cached.

  Parameters:
    `ua` - A user agent string
  Returns:
    The matched pattern groups or the original user agent string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.